/*
 * @Author       : yuanrunwei
 * @Date         : 2020-05-18 12:05:37
 * @LastEditors: XuTongZhang
 * @LastEditTime: 2020-07-29 10:45:59
 * @FilePath     : \batterycloud-admin\src\common\api\axios.js
 */
import axios from 'axios'
import vue from '../../main'
import { Message, Loading } from 'element-ui'
// import { all } from 'core-js/fn/promise'
let api = ''
let loading
const whiteList = ['test', 'production']
// const allowList = [
//   '/platform/upload/platformUploadImg'
// ]

const service = axios.create({
  baseURL: process.env.VUE_APP_API,
  // baseURL: 'http://47.100.59.52:7785',
  timeout: 90000
})

service.interceptors.request.use(
  config => {
    // if (allowList.indexOf(config.url) === -1) {
    let data = {
      'from': 0,
      'page': 1,
      'rows': 10,
      'companyId': 1 || localStorage.getItem('managerid') - 0,
      'sidx': '',
      'sord': '',
      'token': localStorage.getItem('token'),
      'reqdata': {}
    }
    config.data = Object.assign(data, config.data)
    // }
    loading = Loading.service({
      lock: true,
      text: 'Loading',
      spinner: 'el-icon-loading',
      background: 'rgba(0, 0, 0, 0.7)'
    })
    config.headers['platform-sessionId'] = localStorage.getItem('token')
    api = config.url
    return config
  },
  error => {
    Promise.reject(error)
  }
)

service.interceptors.response.use(
  res => {
    return new Promise((resolve, reject) => {
      if (res.data.state === 206) {
        localStorage.clear()
        // sessionStorage.claer()
        vue.$cookies.removeCookies()
        loading.close()
        setTimeout(() => {
          location.reload()
        }, 100)
      }
      // if (allowList.indexOf(api) !== -1) {
      //   loading.close()
      //   resolve(res.data)
      // } else {
      if (res.status === 200) {
        if (res.data.state !== 100) {
          Message({
            message: res.data.msg,
            type: 'error',
            duration: 5 * 1000
          })
          loading.close()
          reject(res.data.msg)
        } else {
          resolve(res.data)
          loading.close()
        }
      } else {
        loading.close()
        Message({
          message: res.statusText,
          type: 'error',
          duration: 5 * 1000
        })
        if (res.status > 100 && res.status < 200) {
          if (whiteList.indexOf(process.env.NODE_ENV) !== -1) {
            let url = `http://monitor.info666.com/monitor/alert?projectAbbr=batterycloud-test&errorMsg=接口：${api}(${res.statusText})&logPath=前端开发环境(${process.env.NODE_ENV})`
            axios.get(url)
            loading.close()
          }
        }
        loading.close()
        reject(res)
      }
      // }
    })
  },
  error => {
    loading.close()
    Message({
      message: '请求异常' + error,
      type: 'error',
      duration: 5 * 1000
    })
  }
)
export default service
